BE-2021-0002: Out-of-bounds vulnerabilities in MicroStation and MicroStation-based applications

Bentley ID: BE-2021-0002
CVE ID: CVE-2021-34871,  CVE-2021-34893,  CVE-2021-34896,  CVE-2021-34903,  CVE-2021-34907,  CVE-2021-46605,  CVE-2021-46606,  CVE-2021-46615,  CVE-2021-46616,  CVE-2021-46628,  CVE-2021-46629,  CVE-2021-46645,  CVE-2021-46647,  CVE-2021-46653
Severity: 7.8 (High)
CVSS v3.1: AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H
Publication date: 7th December 2021
Revision date: 4th February 2022

Summary

MicroStation and MicroStation-based applications may be affected by out-of-bounds vulnerabilities opening maliciously crafted BMP files. Exploiting these vulnerabilities could lead to code execution.

Details

The following vulnerabilities related to this advisory were discovered by TrendMicro ZDI: ZDI-CAN-14695, ZDI-CAN-14846, ZDI-CAN-14863, ZDI-CAN-14876, ZDI-CAN-14880, ZDI-CAN-15399, ZDI-CAN-15400, ZDI-CAN-15409, ZDI-CAN-15410, ZDI-CAN-15458, ZDI-CAN-15459, ZDI-CAN-15531, ZDI-CAN-15533, ZDI-CAN-15539.

Using an affected version of MicroStation or MicroStation-based application to open a BMP file containing maliciously crafted data can force an out-of-bounds read or write. Exploitation of these vulnerabilities within the parsing of BMP files could enable an attacker to execute arbitrary code in the context of the current process. 

Affected Versions

Applications Affected Versions Mitigated Versions
MicroStation Versions prior to 10.16.02.* 10.16.02.* and more recent
Bentley View Versions prior to 10.16.02.*  10.16.02.* and more recent

Recommended Mitigations

Bentley recommends updating to the latest versions of MicroStation and MicroStation-based applications. As a general best practice, it is also recommended to only open BMP files coming from trusted sources.

Acknowledgment

Thanks to Francis Provencher {PRL} for discovering ZDI-CAN-14695.
Thanks to Mat Powell of Trend Micro Zero Day Initiative for discovering the rest of the vulnerabilities related to this advisory.

Revision History

Date Description
7th December 2021 First version of the advisory
4th February 2022 Adding new CVE numbers provided by ZDI